"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SqlLite = void 0;
var react_native_sqlite_storage_1 = __importDefault(require("react-native-sqlite-storage"));
var util_1 = require("./util");
var SqlLite = /** @class */ (function () {
    function SqlLite() {
        react_native_sqlite_storage_1.default.DEBUG(false);
        this.dbName = "lucky.db";
        this.tableName = "";
        this.primaryKey = "id";
        this.hasInit = false;
        this.init();
    }
    SqlLite.prototype.initTable = function () {
    };
    SqlLite.prototype.executeSql = function (sql, isInit) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(!isInit && this.hasInit == false)) return [3 /*break*/, 2];
                        return [4 /*yield*/, util_1.CodeTool.waitTime(2000)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/, new Promise(function (resolve, reject) {
                            var _a;
                            (_a = _this.db) === null || _a === void 0 ? void 0 : _a.executeSql(sql, [], function (res) {
                                resolve(res);
                            }, function (err) {
                                reject(err);
                            });
                        })];
                }
            });
        });
    };
    SqlLite.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this;
                        return [4 /*yield*/, this.open(this.dbName)];
                    case 1:
                        _a.db = _b.sent();
                        return [4 /*yield*/, this.initTable()];
                    case 2:
                        _b.sent();
                        this.hasInit = true;
                        return [2 /*return*/];
                }
            });
        });
    };
    SqlLite.prototype.open = function (dbName) {
        return react_native_sqlite_storage_1.default.openDatabase({ name: dbName, location: 'default' }, function () {
        }, function () { });
    };
    SqlLite.prototype.createTable = function (createTableSql) {
        return this.executeSql(createTableSql, true);
    };
    SqlLite.prototype.checkAndCreateColumn = function (columnName, createColumnSql) {
        return __awaiter(this, void 0, void 0, function () {
            var exitFlag, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (util_1.CodeTool.isStringEmpty(columnName) || util_1.CodeTool.isStringEmpty(createColumnSql)) {
                            return [2 /*return*/, false];
                        }
                        exitFlag = true;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.selectOne(columnName + " is  null")];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        exitFlag = false;
                        return [3 /*break*/, 4];
                    case 4:
                        if (!exitFlag) {
                            try {
                                this.executeSql(createColumnSql);
                            }
                            catch (e) {
                            }
                        }
                        return [2 /*return*/, true];
                }
            });
        });
    };
    SqlLite.prototype.insert = function (item) {
        var property = "";
        var values = "";
        for (var key in item) {
            if (item[key] == undefined || item[key] == null) {
                continue;
            }
            property += key + ",";
            if (typeof item[key] == 'string') {
                values += "'" + item[key] + "',";
            }
            else {
                values += item[key] + ",";
            }
        }
        property = property.substring(0, property.length - 1);
        values = values.substring(0, values.length - 1);
        return this.executeSql("INSERT INTO " + this.tableName + " (" + property + ") VALUES (" + values + ")");
    };
    SqlLite.prototype.updateByCondition = function (newParams, conditionParams) {
        return __awaiter(this, void 0, void 0, function () {
            var property, conditions, key, key, updateResult;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        property = "";
                        conditions = "";
                        for (key in newParams) {
                            if (newParams[key] == undefined || newParams[key] == null) {
                                continue;
                            }
                            property = property + key + "=" + newParams[key] + ",";
                        }
                        for (key in conditionParams) {
                            if (conditionParams[key] == undefined) {
                                continue;
                            }
                            if (typeof conditionParams[key] == 'string') {
                                conditions = conditions + (key + "='" + conditionParams[key] + "' AND ");
                            }
                            else {
                                conditions = conditions + key + "=" + conditionParams[key] + " AND ";
                            }
                        }
                        property = property.substring(0, property.length - 1);
                        conditions = conditions.substring(0, conditions.length - 5);
                        return [4 /*yield*/, this.executeSql("UPDATE " + this.tableName + "  SET (" + property + ") WHERE " + conditions)];
                    case 1:
                        updateResult = _a.sent();
                        if (updateResult && updateResult.rowsAffected) {
                            return [2 /*return*/, true];
                        }
                        return [2 /*return*/, false];
                }
            });
        });
    };
    SqlLite.prototype.updateByPrimaryKey = function (newParams) {
        return __awaiter(this, void 0, void 0, function () {
            var primaryVal, property, key, updateResult;
            return __generator(this, function (_a) {
                if (newParams == undefined || newParams[this.primaryKey] == undefined) {
                    return [2 /*return*/, false];
                }
                primaryVal = newParams[this.primaryKey];
                delete newParams[this.primaryKey];
                property = "";
                for (key in newParams) {
                    if (newParams[key] == undefined || newParams[key] == null) {
                        continue;
                    }
                    if (typeof newParams[key] == 'string') {
                        property = property + (key + "='" + newParams[key] + "'") + ",";
                    }
                    else {
                        property = property + (key + "=" + newParams[key]) + ",";
                    }
                }
                property = property.substring(0, property.length - 1);
                updateResult = this.executeSql("UPDATE " + this.tableName + "  SET " + property + " WHERE " + this.primaryKey + "=" + primaryVal);
                if (updateResult && updateResult.rowsAffected) {
                    return [2 /*return*/, true];
                }
                return [2 /*return*/, false];
            });
        });
    };
    SqlLite.prototype.deleteByPrimaryKey = function (primaryValue) {
        return __awaiter(this, void 0, void 0, function () {
            var delResult;
            return __generator(this, function (_a) {
                delResult = this.executeSql("DELETE FROM " + this.tableName + " WHERE " + this.primaryKey + " = " + primaryValue + " ");
                if (delResult && delResult.rows && delResult.rows.length) {
                    return [2 /*return*/, true];
                }
                return [2 /*return*/, false];
            });
        });
    };
    SqlLite.prototype.selectByPrimaryKey = function (primaryValue) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!primaryValue) {
                            return [2 /*return*/, null];
                        }
                        return [4 /*yield*/, this.select(this.primaryKey + "=" + primaryValue)];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result[0] ? result[0] : null];
                }
            });
        });
    };
    SqlLite.prototype.select = function (selectSql, orderSql) {
        return __awaiter(this, void 0, void 0, function () {
            var sql, selectResult;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (util_1.CodeTool.isStringEmpty(selectSql)) {
                            selectSql = " 1=1 ";
                        }
                        sql = "SELECT * FROM " + this.tableName + " WHERE " + selectSql;
                        if (orderSql) {
                            sql += " order by " + orderSql + " ";
                        }
                        return [4 /*yield*/, this.executeSql(sql)];
                    case 1:
                        selectResult = _a.sent();
                        if (selectResult && selectResult.rows && selectResult.rows.length) {
                            return [2 /*return*/, selectResult.rows.raw()];
                        }
                        return [2 /*return*/, []];
                }
            });
        });
    };
    SqlLite.prototype.selectBySql = function (selectSql) {
        return __awaiter(this, void 0, void 0, function () {
            var selectResult;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.executeSql(selectSql)];
                    case 1:
                        selectResult = _a.sent();
                        if (selectResult && selectResult.rows && selectResult.rows.length) {
                            return [2 /*return*/, selectResult.rows.raw()];
                        }
                        return [2 /*return*/, []];
                }
            });
        });
    };
    SqlLite.prototype.selectOne = function (selectSql) {
        return __awaiter(this, void 0, void 0, function () {
            var sql, selectResult;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        sql = "";
                        if (util_1.CodeTool.isStringEmpty(selectSql)) {
                            sql = "SELECT * FROM " + this.tableName + "  limit 1";
                        }
                        else {
                            sql = "SELECT * FROM " + this.tableName + "  WHERE " + selectSql + " limit 1";
                        }
                        return [4 /*yield*/, this.executeSql(sql)];
                    case 1:
                        selectResult = _a.sent();
                        if (selectResult && selectResult.rows && selectResult.rows.length) {
                            return [2 /*return*/, selectResult.rows.raw()[0]];
                        }
                        return [2 /*return*/, null];
                }
            });
        });
    };
    return SqlLite;
}());
exports.SqlLite = SqlLite;
